#ifndef LIST_H
#define LIST_H

#include "Node.h"

template <class T>
class List {
public:
	List(unsigned int sz=0, const T& val=T());
	List(const List<T>& org);
	~List();
	List<T>& operator=(const List<T>& rhs);
	unsigned int size() const;

private:
	unsigned int numEl;
	Node<T>* start;
};

template <class T>
List<T>::List(unsigned int sz, const T& val) : numEl(sz),
start(NULL)
{
	if(numEl) {
		Node<T>* prev = NULL;
		Node<T>* current = NULL;
		for(unsigned int i=0; i<numEl; ++i) {
			current = new Node<T>(val, prev);
			prev = current;
		}
		start = current;
	}
}

template <class T>
unsigned int List<T>::size() const
{
	return numEl;
}

template <class T>
List<T>::~List()
{
	Node<T>* current = start;
	while(current!=NULL) {
		start = current->next;
		delete current;
		current = start;
	}


#endif