#ifndef NODE_H
#define NODE_H

template <class T>
class List<T>;

template <class T>
class Node {
private:
	Node();
	Node(const T& val, Node<T>* nt=NULL);
	Node(const Node<T>& org);
	~Node();
	Node<T>& operator=(const Node<T>& rhs);
	T value;
	Node<T>* next;
	friend List<T>;
};

template <class T>
Node<T>::Node() : next(NULL)
{
}

template <class T>
Node<T>::~Node()
{
}

template <class T>
Node<T>::Node(const T& val, Node<T>* nt) : value(val), next(nt)
{
}

template <class T>
Node<T>::Node(const Node<T>& org) : value(org.value),
next(org.next)
{
}

template <class T>
Node<T>& Node<T>::operator=(const Node<T>& rhs)
{
	if(this != &rhs) {
		value = rhs.value;
		next = rhs.next;
	}
	return *this;
}

#endif